{--------------------------------------------------------}
{
{    Manipulacao de arquivos
{
{    Autor: Marcelo Luis Pinheiro
{
{    Orientador Academico: Jose' Antonio Borges
{
{    Em 10/12/93
{
{--------------------------------------------------------}

Unit edArq;

interface
uses
    DVcrt, DVWin, windows, sysUtils, classes, dvArq, dvexec,
    edvars, edMensag, edLinha, edTela,
    edMd5,
    edDoc, edPdf, edRetoma;

procedure cmdArquivo;
procedure informaNomeArq (soletra: boolean);
function testaExtensao (nomeArq: string): boolean;
function abreArquivo: boolean;
function abreArqSemCriar: boolean;
procedure salvaArquivo (linha1, linha2: integer);
procedure salvaJuntaLinhas (linha1, linha2: integer);
procedure trocaArquivo;
procedure salvaComo;
procedure gravaETermina;
procedure terminaPrograma;
procedure executaPalavra;
procedure imprime;

var     md5DoArquivo: string;

implementation

uses edReform;

var arq: file;
    arqSaida: text;
    linhasDivididas: boolean;
    bufArq: array [0..1023] of char;
    pbufArq, lidosBuf: integer;
    fimDoArq: boolean;

{--------------------------------------------------------}

{----------------------------------------}
{       Retorna o nome do arquivo com o caminho completo
{----------------------------------------}

function pegaCaminhoCompleto (nomeArq: string): string;
var dirAtual: string;
begin
    dirAtual := '';
    if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) then
        begin
            getDir (0, dirAtual);
            if dirAtual[length (dirAtual)] <> '\' then
                dirAtual := dirAtual + '\';
        end;

    pegaCaminhoCompleto := dirAtual + nomeArq;
end;

procedure terminaPrograma;
begin
    salvaPosicao;

    if not somenteLeitura then
        fala ('EDFIMPRC')
    else
        sintClek;

    if tamMaxLinha <> 79 then
        trocaTamTela;

    SintFim;
    doneWinCrt;
end;

{--------------------------------------------------------}

procedure informaNomeArq (soletra: boolean);
begin
    fala ('EDNOME');
    write (' ', nomearq);
    if soletra then
        sintSoletra (nomeArq)
    else
        sintetiza (nomeArq);
    delay (500);
end;


{--------------------------------------------------------}

procedure devolveCaracArq (c: char);
begin
   pbufArq := pbufArq - 1;
end;

{--------------------------------------------------------}

function pegaCaracArq: char;
begin
    if pbufArq >= lidosBuf then
         begin
             {$I-} blockread (arq, bufArq, 1024, lidosBuf);  {$i+}
             pbufArq := 0;

             if ioresult <> 0 then
                 begin
                     fala ('EDERRLEI');
                     pegaCaracArq := #$0d;
                     fimDoArq := true;
                     exit;
                 end;
         end;

    pegaCaracArq := bufArq [pBufArq];
    pbufArq := pbufArq + 1;
    fimDoArq := (pBufArq >= lidosBuf) and eof (arq);
end;

{--------------------------------------------------------}

procedure inicBuffer;
begin
    pbufArq := 9999;
    lidosBuf := 0;
    devolveCaracArq (pegaCaracArq);
    fimDoArq := eof (arq) and (pBufArq >= lidosBuf);
end;

{--------------------------------------------------------}

function carregaUmaLinha (var arq: file) : string;
var s: string;
    c: char;
    fimDaLinha: boolean;

begin
    fimDaLinha := false;
    s := '';

    repeat
        c := pegaCaracArq;

        if (c = #$0d) or (c = #$0a) then
            fimDaLinha := true
        else
            if c = #9 then
                s := s + '        '
            else
                if c in [#0..#31] then
                    s := s + '#'
                else
                    s := s + c;

//neno        if length (s) > 250 then
        if length (s) > 160 then
            begin
                if not linhasDivididas then
                    begin
                        fala ('EDLINGRA') ;
                              { linhas grandes foram divididas }
                        linhasDivididas := true;
                    end;

                if length (s) >= 180 then
                    fimDaLinha := true;

                if c = ' ' then
                    begin
                        fimDaLinha := true;
                        while (c = ' ') and (not fimDoArq) do
                           c := pegaCaracArq;
                        if (c <> #$0d) and (c <> #$0a) then
                            devolveCaracArq (c);
                    end;
            end;

    until fimDaLinha or fimDoArq;

    if (not fimDoArq) and (c = #$0d) then
        begin
            c := pegaCaracArq;
            if c <> #$0a then
                devolveCaracArq (c);
        end;

    carregaUmaLinha := s;
end;

{--------------------------------------------------------}

procedure fazCargaDoArquivo;
var
    s: string;
Begin
    linhasDivididas := false;

    While not fimDoArq do
        begin
            s := carregaUmaLinha (arq);
            if (s <> '') and (veioDoDos) then
                OemToAnsi(@s[1], @s[1]);
            insereLinha (s, false);
            posy := posy + 1;
        end;

    close (arq);
    veioDoDos := false;  // futuras leituras serem em modo Windows
end;

{--------------------------------------------------------}

function tiraCaminhoDir (s: string): string;
begin
    tiraCaminhoDir := s;
    while (s <> '') and ( pos ('\', s) <> 0) do
        delete (s, 1, pos('\', s));
    while (s <> '') and ( pos ('/', s) <> 0) do
        delete (s, 1, pos('/', s));
    if s <> '' then
        tiraCaminhoDir := s;
end;

{--------------------------------------------------------}

function testaExtensao (nomeArq: string): boolean;
begin
    nomeArq := tiraCaminhoDir (nomeArq);
    if pos ('.', nomeArq) <> 0 then
        testaExtensao := true
    else
        testaExtensao := false;
end;

{--------------------------------------------------------}

function abreArquivo: boolean;
var
    i: integer;
    tituloJan: array [0..144] of char;
    s: string;
    c, c2: char;
begin
    abreArquivo := true;
    emUtf := false;

    for i := 9 to 25 do
        begin
             gotoxy (1, i);
             clreol;
        end;

    if nomeArq = '' then
        begin
            fala ('EDDIGNOM');
            nomeArq := trim(obtemNomeArq (15));
            if (nomeArq = '') and (teclaObtemNomeArq = ENTER) then
                begin
                    fala ('EDRECUST');   {'Edies recentes, use as setas.'}
                    nomeArq := trim(obtemNomeAntigo);
                end;
            if (nomeArq = '') or ((nomeArq[length(nomeArq)] in ['\', '/'])) then
                begin
                    abreArquivo := false;
                    exit;
                end;
        end;

    nomeArq := pegaCaminhoCompleto (nomeArq);
    if testaExtensao (nomeArq) then
        begin
            if pos ('.PDF',maiuscansi(nomeArq)) = length (nomeArq) - 3 then
                nomeArq := convertPdfParaTxt ( nomeArq)
            else
                nomeArq := convertDocParaTxt ( nomeArq);
            while sintFalando do waitMessage;
        end
    else
        begin
            assign (arq, nomeArq);
            {$i-} reset (arq, 1); {$i+}
            if ioresult = 0 then
                {$i-} close (arq) {$i+}
            else
                nomeArq := nomeArq + '.' + extPadrao;
        end;

    if nomeArq = '' then
        begin
            abreArquivo := false;
            fala ('EDDESIST');
            exit;
        end;

    assign (arq, nomeArq);
    {$i-} reset (arq, 1); {$i+}
    if ioresult <> 0 then
        begin
             maxLinhas := 1;
             getmem (texto^ [1], 1);
             texto^[1]^ := '';
             fala ('EDARQNOV');
        end
    else
        begin
            maxLinhas := 0;
            posy := 1;
            inicBuffer;
            fazCargaDoArquivo;
            if maxlinhas = 0 then
                begin
                    maxLinhas := 1;
                    getmem (texto^ [1], 1);
                    texto^[1]^ := '';
                end;

            if informaCarga then fala ('EDARQCRG');
            informaCarga := true;
        end;

    posx := 1;
    posy := recupPosicao;
    if posy > maxLinhas then posy := 0;
    if posy > 1 then
        begin
            fala ('EDRETOMA');    {'Retomando na linha '}
            textBackground (BLUE);
            sintWriteint (posy);
            textBackground (BLACK);
        end
    else
        posy := 1;

    s := tiraCaminhoDir (nomeArq);
    if length (s) > 124 then
        s := copy (s, 1, 124) + '...';
    strPCopy (tituloJan, s + ' - EDIVOX');
    setWindowText (crtWindow, tituloJan);

    for i := 1 to maxLinhas do
         if detectaUtf (texto^[i]^) then
             begin
                repeat
                    fala ('EDORIUTF'); {'Original contm texto em UTF-8 na linha '}
                    sintWriteInt (i);
                    fala ('EDDECODI'); {'Deseja decodificar o texto?'}
                    sintLeTecla(c, c2);
                until upcase(c) in ['S', 'N', ESC, ENTER];
                if upcase(c) in ['S', ENTER] then
                    emUtf := true;
                break;
            end;

    if emUtf then
         for i := 1 to maxLinhas do
             begin
                 s := texto^[i]^;
                 freemem (texto^ [i], length (texto^[i]^)+1);
                 if (pos('﻿', s) = 1) then delete (s, 1, 3);
                 s := utfToAnsi(s);
                 getmem (texto^[i], length(s) + 1);
                 texto^[i]^ := s;
             end;

    md5DoArquivo := calculaMd5;
end;

{--------------------------------------------------------}

function abreArqSemCriar: boolean;
begin
    abreArqSemCriar := false;

    fala ('EDDIGNOM');
    nomeArq := trim(obtemNomeArq (15));
    if (nomeArq = '') or (nomeArq[length(nomeArq)] in ['\', '/']) then
        begin
            fala ('EDDESIST');
            exit;
        end;

    nomeArq := pegaCaminhoCompleto (nomeArq);
    if testaExtensao (nomeArq) then
        begin
            if pos ('.PDF',maiuscansi(nomeArq)) = length (nomeArq) - 3 then
                nomeArq := convertPdfParaTxt ( nomeArq)
            else
                nomeArq := convertDocParaTxt ( nomeArq);
            while sintFalando do waitMessage;
        end
    else
        begin
            assign (arq, nomeArq);
            {$i-} reset (arq, 1); {$i+}
            if ioresult = 0 then
                {$i-} close (arq) {$i+}
            else
                nomeArq := nomeArq + '.' + extPadrao;
        end;

    if nomeArq = '' then
        begin
            fala ('EDDESIST');
            exit;
        end;

    assign (arq, nomeArq);
    {$i-} reset (arq, 1); {$i+}
    if ioresult <> 0 then
        begin
            fala ('EDARQNAO');
            exit;
        end;

    inicBuffer;
    fazCargaDoArquivo;
    abreArqSemCriar := true;
end;

{--------------------------------------------------------}

function abreArqSaida: boolean;
var
    resp : char;
label inicio;
begin
    abreArqSaida := true;
inicio:
    limpaBufTec;

    If (nomeArq = '') then
         begin
             fala ('EDNOMGRV');  { Nome do arquivo a gravar: }
             sintReadln (nomearq);
             nomeArq := trim(nomearq);
             if nomearq = '' then
                 begin
                     abreArqSaida := false;
                     fala ('EDDESIST');
                     exit;
                 end;

             if not testaExtensao (nomeArq) then
                 if not fileExists (nomeArq) then
                     nomeArq := nomeArq + '.' + extPadrao;

             if fileExists (nomeArq) then
                 begin
                     fala ('EDREESCR');
                     resp := upcase (sintReadKey);
                     if resp <> 'S' then
                          begin
                              abreArqSaida := false;
                              fala ('EDESCCAN');
                          end;
                 end;
         end;
end;

{--------------------------------------------------------}

procedure salvaArquivo (linha1, linha2: integer);
var
    i: integer;
label inicio, fechaArq;
begin

inicio:
    if not abreArqSaida then exit;

    assign (arqSaida, nomeArq);
    {$i-} rewrite (arqSaida); {$I+}
    if ioresult <> 0 then
        begin
            fala ('EDERRESC');
            nomeArq := '';
            goto inicio;
        end;

    while (linha2 >= linha1) and (texto^[linha2]^ = '') do
            linha2 := linha2 - 1;

    For i := linha1 to linha2 Do
        begin
            {$i-} writeln (arqSaida, texto^[i]^); {$I+}
            if ioresult <> 0 then
                begin
                    fala ('EDERRESC');
                    goto fechaArq;
                end;
        end;

fechaArq:
    {$I-} close (arqSaida); {$I+}
    if ioresult <> 0 then
        begin
            fala ('EDERRESC');
            exit;
        end;

    if somenteLeitura then
        fala ('EDSOMLEI')    {'Este arquivo  somente leitura,}
                             { provavelmente no ser gravado'}
    else
        fala ('EDARQGRV');
    md5DoArquivo := calculaMd5;
end;

{--------------------------------------------------------}

procedure salvaJuntaLinhas (linha1, linha2: integer);
var i: integer;
    s, si: string;
label inicio;
begin
inicio:
    if not abreArqSaida then exit;

    assign (arqSaida, nomeArq);
    {$i-} rewrite (arqSaida); {$I+}
    if ioresult <> 0 then
        begin
            fala ('EDERRESC');
            nomeArq := '';
            goto inicio;
        end;

    s := '';
    for i := iniBloco to fimBloco do
        begin
            si := texto^[i]^;

            if trim(si) = '' then
                s := s + #$0d + #$0a
            else

            if copy (si, 1, 4) = '    ' then
                begin
                    s := s + #$0d + #$0a;
                    while copy (si, 1, 4) = '    ' do
                        begin
                            s := s + ^i;
                            delete (si, 1, 4);
                        end;
                    s := s + si;
                end
            else

            if si[1] = ' ' then
                begin
                    delete (si, 1, 1);
                    s := s + #$0d + #$0a + si;
                end
            else
                s := s + ' ' + texto^[i]^;
        end;

    delete (s, 1, 1);
    {$I-} write (arqSaida, s);  {$I-}
    if ioresult <> 0 then
        fala ('EDERRESC');

    {$I-} close (arqSaida); {$I+}
    if ioresult <> 0 then
        fala ('EDERRESC')
    else
        fala ('EDARQGRV');
end;

{--------------------------------------------------------}

Procedure limpaMemoria;
var i: integer;
begin
    For i := 1 to maxlinhas Do
        If texto^ [i] <> nil then
            freemem (texto^ [i], length (texto^[i]^)+1);
end;

{--------------------------------------------------------}

procedure trocaArquivo;
var
    resp : char;
begin
    salvaPosicao;

    if     md5DoArquivo = calculaMd5 then
    begin
        repeat
            fala ('EDCNFSAI');     {--- confirma saida ---}
            resp := leTeclaMaiusc;
        until resp in ['S','N', ESC];

        if resp in ['N', ESC] then
            begin
                fala ('EDDESIST');
                exit;
            end;
    end
    else
    begin
        repeat
            fala ('EDQUERSV');
            resp := sintReadKey;
            if resp = #27 then
               begin
                    fala ('EDDESIST');
                    exit;
                end;
            resp := upcase (resp);
        until resp in ['S', 'N'];

        if resp = 'S' then
            salvaArquivo (1, maxLinhas);
    end;

    limpaMemoria;

    nomearq := '';
    if not abrearquivo then
        terminaPrograma;
end;

{--------------------------------------------------------}

procedure salvaComo;
var
    nomeNovo, s: string;
    c : char;
    tituloJan: array [0..144] of char;
begin
    fala ('EDDIGNOM');
    sintReadln (nomenovo);
    nomeNovo := trim(nomenovo);

    if nomeNovo = '' then
        begin
            fala ('EDDESIST');
            exit;
        end;

    fala ('EDFORTXT');
    c := sintReadKey;
    if c = #$1b then
        begin
            fala ('EDDESIST');
            exit;
        end;

    nomeArq := nomeNovo;
    if not testaExtensao (nomeArq) then
        nomeArq := nomeArq + '.' + extPadrao;
    somenteLeitura := false;
    salvaArquivo (1, maxlinhas);

    s := tiraCaminhoDir (nomeArq);
    if length (s) > 124 then
        s := copy (s, 1, 124) + '...';
         strPCopy (tituloJan, s + ' - EDIVOX');
    setWindowText (crtWindow, tituloJan);
    nomeArq := pegaCaminhoCompleto (nomeArq);
end;

{--------------------------------------------------------}

procedure gravaETermina;
begin
    salvaArquivo (1, maxLinhas);
    terminaPrograma;
end;

{--------------------------------------------------------}

Procedure cmdArquivo;
var
    tecla: char;
label deNovo;
begin
    fala ('EDOPCAO');   { qual opcao ? }
    tecla := leTeclaMaiusc;

deNovo:
    escreveTela;

    case tecla of

        'I': informaNomeArq (true);
        'S': salvaArquivo (1, maxlinhas);
        'N': trocaArquivo;
        'C': salvaComo;
        'F': gravaETermina;
        'A': terminaPrograma;
        'X': salvaArquivo (1, maxlinhas);


       #$0: begin
                tecla := ajuda (readkey, 'EDAJAR', 8);
                goto deNovo;
            end;
      #$1b: begin
                fala ('EDDESIST');
                exit;
            end
    else
        sintBip;
    end;

    escreveTela;
end;

{--------------------------------------------------------}

procedure executaPalavra;
var
    campo, comando: string;
    x1, x2: integer;
const
    espurios: set of char = ['<', '"', '(', '{', '[', '-', '=', '.', '_', 
                             '>', '*', '!', '?', ')', '}', ']'];
begin
    campo := trim(texto^[posy]^);
    if campo = '' then
        begin
            fala ('EDNEXEC');    {'No pude executar'}
            exit;
        end;

    x1 := posx;
    while (x1 > 1) and (campo[x1-1] <> ' ') do
       x1 := x1 - 1;
    x2 := posx;
    while (x2 < length(campo)) and (campo[x2] <> ' ') do
        x2 := x2 + 1;
    if (x2 <= length(campo)) and (campo[x2] = ' ') then x2 := x2 - 1;
    comando := copy (campo, x1, x2-x1+1);

    while (comando <> '') and (comando[1] in espurios) do
        delete (comando, 1, 1);
    while (comando <> '') and (comando[length(comando)] in espurios) do
        delete (comando, length(comando), 1);

    if comando = '' then
        fala ('EDNEXEC')    {'No pude executar'}
    else
        executaArquivo(comando);
end;

{--------------------------------------------------------}

procedure imprime;
var impressor: string;
    nome: string;
    aux: boolean;
begin
    aux := somenteLeitura;
    somenteLeitura := false;
    salvaArquivo (1, maxlinhas);
    somenteLeitura := aux;
    impressor := sintAmbiente ('EDIVOX', 'IMPRESSOR');
    if impressor = '' then impressor := 'c:\winvox\listavox.exe';

    nome := nomeArq;
    if pos (' ', nome) <> 0 then
        nome := '"' + nome + '"';
    executaProg(impressor, '.', nome);
end;

end.
