unit eddicion;

interface

uses
    DVcrt, DVWin, dvDic, sysUtils, classes,
    edVars, edMensag, edLinha, edArq, edAcento, edEmbel, edTela, dvForm;

procedure ativaDicionario;
function verificaDicionario (iniBloco, fimBloco: integer): boolean;
procedure verificaPalavraAntes;
procedure trocaPalavraDic;

implementation

const caracErro = '#';

var
    listaAlternativa: TStringList;

const
     LETRAS_DE_PALAVRA: set of char =
         ['A'..'Z', '', '', '', '', '',
          '', '', '', '', '', '', '', '', '', '', '', '',
          'a'..'z', '', '', '', '', '',
          '', '', '', '', '', '', '', '', '', '', '', '',
          '-', ''''];

{----------------------------------------------------------------}
{                ativa/desativa dicionrio online
{----------------------------------------------------------------}

procedure ativaDicionario;
begin
    verificaDicionario (1, 0);
    dicionarioAtivado := not dicionarioAtivado;
    if dicionarioAtivado then
        fala ('EDDICIOA')    {'Dicionrio ativado'}
    else
        fala ('EDDICIOD');   {'Dicionrio desativado'}
end;

{----------------------------------------------------------------}
{                           processa
{----------------------------------------------------------------}

procedure processaDic (iniBloco, fimBloco: integer);
var s, saida, palavra: string;
    lin, i: integer;
    ok: boolean;
    numErros: integer;
label fim, continuaPalavra;

begin
    numErros := 0;
    for lin := iniBloco to fimBloco do
        begin
            s := texto^[lin]^;
            saida := '';
            i := 1;

            while i <= length (s) do
                begin
                    while (i <= length (s)) and not (s[i] in dicAlfabeto) do
                        begin
                            saida := saida + s[i];
                            i := i + 1;
                        end;

                    if i > length (s) then break;

                continuaPalavra:
                    while (i <= length (s)) and (s[i] in dicAlfabeto) do
                        begin
                            palavra := palavra + s[i];
                            i := i + 1;
                        end;

                    if (i < length (s)-1) and (s[i] in ['-', ''''])
                                          and (s[i+1] in dicAlfabeto) then
                        begin
                            palavra := palavra + s[i];
                            i := i + 1;
                            goto continuaPalavra;
                        end;

                     ok := procuraDic (palavra);
                     if ok then
                         saida := saida + palavra
                     else
                         begin
                             if copy (saida, length(saida), 1) = caracErro then
                                 saida := saida + palavra
                             else
                                 saida := saida + caracErro + palavra;
//Neno
                             if (numErros mod 100) = 0 then
                                 sintBip;
                             numErros := numErros + 1;
                         end;
                     palavra := '';
                end;

            if texto^[lin]^ <> saida then
                begin
                    posy := lin;
                    insereLinha (saida, false);
                    posy := lin+1;
                    removeLinha(false);
                    posy := lin;
                end;
        end;

    if fimBloco >= iniBloco then
        if (numErros = 0)  then Fala ('EDOK')
                           else sintetiza (intToStr (numErros));
    sintClek;
end;

{----------------------------------------------------------------}
{                           verifica bloco
{----------------------------------------------------------------}

function verificaDicionario (iniBloco, fimBloco: integer): boolean;
var s: string;
begin
    if not dicCarregado then
        begin
            nomeArqDic := 'c:\winvox\diciona.dic';
            s := sintAmbiente ('DICIONARIO', 'ARQDIC');
            if s <> '' then nomeArqDic := s;

            nomeArqSufixos := 'c:\winvox\diciona.suf';
            s := sintAmbiente ('DICIONARIO', 'ARQSUFIXOS');
            if s <> '' then nomeArqSufixos := s;

            nomeArqInexist := 'c:\winvox\diciona.exc';
            s := sintAmbiente ('DICIONARIO', 'ARQINEXIST');
            if s <> '' then nomeArqInexist := s;

            nomeArqNomes := 'c:\winvox\diciona.nom';
            s := sintAmbiente ('DICIONARIO', 'ARQNOMES');
            if s <> '' then nomeArqNomes := s;

            nomeArqSugTroca := 'c:\winvox\diciona.sug';
            s := sintAmbiente ('DICIONARIO', 'ARQSUGERE');
            if s <> '' then nomeArqSugTroca := s;

            dicCarregado := carregaDic (nomeArqDic, nomeArqSufixos,
                                        nomeArqInexist, nomeArqNomes, nomeArqSugTroca) = 0;
        end;

    verificaDicionario := dicCarregado;
    if not dicCarregado then exit;

    processaDic (iniBloco, fimBloco);
end;

{----------------------------------------------------------------}
{              extrai uma palavra antes do cursor
{----------------------------------------------------------------}

function descobrePalavraAntes (x: integer): string;
var s, pal: string;
    i: integer;
    c: char;
begin
    descobrePalavraAntes := '';
    if (posy <= 0) or (x <= 1) then exit;
    s := texto^[posy]^;
    delete (s, x, 999);
    s := trim (s);
    pal := '';
    for i := length (s) downto 1 do
        begin
            c := s[i];
            if not (c in LETRAS_DE_PALAVRA) then break;
            pal := c + pal;
        end;
    descobrePalavraAntes := pal;
end;

{----------------------------------------------------------------}
{                    verifica uma palavra
{----------------------------------------------------------------}

procedure verificaPalavraAntes;
var pal: string;
begin
    pal := descobrePalavraAntes (posx);
    if pal = '' then exit;
    if not procuraDic(pal) then
        begin
            sintBip;
            sintBip;
        end;
end;

{----------------------------------------------------------------}
{         mostra as alternativas  grafia de uma palavra
{----------------------------------------------------------------}

function mostraAlternativasGrafia (s: string): string;
var i, nsel: integer;
begin
    if not dicionarioAtivado then ativaDicionario;

    listaAlternativa.clear;
    geraAlternativasDic (s, 1, listaAlternativa);
    if listaAlternativa.count = 0 then
        begin
            fala ('EDSEMSUG');    {'Sem sugestes'}
            exit;
        end;

    fala ('EDALTERN');    {'Alternativas: use as setas'}

    popupMenuCria(40, 9, 30, listaAlternativa.count, RED);
    for i := 0 to listaAlternativa.Count-1 do
        popupMenuAdiciona('', listaAlternativa[i]);
    nsel := popupMenuSeleciona;

    if nsel > 0 then
        begin
            mostraAlternativasGrafia := listaAlternativa[nsel-1];
            write (' -> ');
            sintWrite (listaAlternativa[nsel-1]);
            clreol;
        end
    else
        fala ('EDDESIST');    {'Desistiu'}
end;

procedure trocaPalavraDic;
var s, pal, pal2: string;
    x: integer;
begin
    if (posy <= 0) then exit;

    s := texto^[posy]^;
    x := posx;
    while (x > 1) and (s[x-1] = ' ') do
        x := x - 1;
    while (x <= length(s)) and (s[x] in LETRAS_DE_PALAVRA) do
        x := x + 1;

    pal := descobrePalavraAntes (x);
    if pal <> '' then
        begin
            x := x - length (pal);
            pal2 := mostraAlternativasGrafia (pal);
            if pal2 <> '' then
                begin
                    delete (s, x, length (pal));
                    if (x > 1) and (s[x-1] = '#') then
                        begin
                            x := x - 1;
                            delete (s, x, 1);
                        end;
                    insert (pal2, s, x);
                    removeLinha (false);
                    insereLinha (s, false);
                    posx := x + length (pal2);
                end;
        end
    else
        sintBip;
end;

initialization
    dicCarregado := false;
    listaAlternativa := TStringList.Create;
    listaAlternativa.sorted := true;
    listaAlternativa.Duplicates := dupIgnore;
end.
