{--------------------------------------------------------}
{
{    Rotinas de tratamento de linhas do EDIVOX
{
{    Autor: Marcelo Luis Pinheiro
{
{    Orientador Academico: Jose' Antonio Borges
{
{    Em 10/12/93
{
{--------------------------------------------------------}

Unit edLinha;

interface
uses
    DVcrt, DVWin, sysutils,
    edvars,  edMensag, edTela;

procedure cmdLinha;
Procedure insereLinha (conteudo : String; falando: boolean) ;
Procedure insereProxLinha (conteudo : String; falando: boolean) ;
Procedure Removelinha (falando: boolean);
procedure voltaRemovida;
procedure quebraLinha;
procedure insereNaLinha (conteudo: string);

implementation

{--------------------------------------------------------}

Procedure insereLinha (conteudo : String; falando: boolean) ;
Var
    i : integer;
Begin
    if length (texto^) <= maxLinhas+10 then
        setLength (texto^, maxLinhas + 50000);

    For i := maxLinhas downto posy  Do
        texto^ [i+1] := texto^ [i];

    inc (maxlinhas);
    if length (texto^) <= maxLinhas then
        begin
            setLength (texto^, maxLinhas + 1000);
            sintBip;
        end;

    getmem (texto^[posy], length(conteudo) + 1);
    texto^ [posy]^ := conteudo;

    posx := length (conteudo)+1;

    if falando then
        fala ('EDLINSER');

    if posy < inibloco then
        inibloco := inibloco + 1;
    if posy <= fimbloco then
        fimbloco := fimbloco + 1;
    if posy < salvaCury then
        salvaCury := salvaCury + 1;
end;

{--------------------------------------------------------}

Procedure insereProxLinha (conteudo : String; falando: boolean) ;
Begin
    posy := posy + 1;
    insereLinha (conteudo, false);

    if falando and (posy < maxlinhas) then
        fala ('EDLINSER');
end;

{-----------------------------}

Procedure Removelinha (falando: boolean);
Var
    p: integer;
Begin
    linhaRemovida := texto^[posy]^;

    If posy< maxlinhas then
        begin
            freemem (texto^ [posy], length (texto^[posy]^)+1);
            dec (maxlinhas);
            For p :=posy to maxlinhas Do
                texto^ [p]:=texto^ [p+1];
       end
    else
        If posy = maxlinhas Then
            begin
                freemem (texto^ [posy], length (texto^[posy]^)+1);
                getmem (texto^ [posy], 1);
                texto^ [posy]^ := '';
                if falando then sintBip;
            end;

    posx := 1;
    if falando then
        fala ( 'EDLINREM' );

    if posy < iniBloco then
        iniBloco := iniBloco - 1;
    if posy <= fimBloco then
        fimBloco := fimBloco - 1;

    if posy = salvaCury then
        begin
            salvaCurx := 1;
            salvaCury := 1;
        end;

    if posy < salvaCury then
        salvaCury := salvaCury - 1;
end;

{--------------------------------------------------------}

procedure voltaRemovida;
begin
    if linhaRemovida = '' then
        sintBip
    else
        begin
            insereLinha (linhaRemovida, true);
            linhaRemovida := '';
        end;
end;

{--------------------------------------------------------}

procedure juntaLinhas;
var linha: string;
    salvax, salvay: integer;
begin
    if posy < maxlinhas then
       begin
           if length (texto^ [posy]^) + length (texto^ [posy+1]^) > 250 then
               begin
                   fala ('EDLGRAND');
                   exit;
               end;

           linha := texto^ [posy]^ + ' ' + texto^ [posy+1]^;
           salvax := posx;  salvay := posy;
           removeLinha (false);
           removeLinha (false);
           insereLinha (linha, false);
           posx := salvax;  posy := salvay;
           fala ('EDLINJUN');
       end;
end;

{-----------------------------}

Procedure quebraLinha;
Var
   linha1, linha2: String;
Begin
    If posx = 1
       Then Begin
            insereLinha ('', false);
            posy := posy + 1;
            fala ('EDLINQUE');
            end
       Else
       If posx > length ( texto^[posy]^) then
           juntaLinhas
       Else
           begin
               linha1 := copy (texto^ [posy]^, 1, posx-1);
               linha2 := copy (texto^ [posy]^, posx,
                                      length (texto^[posy]^)-posx+1);
               removeLinha (false);
               insereLinha (linha2, false);
               insereLinha (linha1, false);
               posy := posy + 1;
               posx := 1;
               fala ('EDLINQUE');
            end;
end;

{--------------------------------------------------------}

procedure editaOuApagaLinha (noInicio: boolean; apagaLinha: boolean);
var
    y, yIni, yFim, salvaY, p, salvaIniBloco, salvaFimBloco: integer;
    textoBusc, s: string;
    c: CHAR;
begin
    repeat
        textoBusc := '';
        if apagaLinha then
            fala ('EDQUATRE') {'Qual o texto das linhas a excluir?'}
        else
fala ('EDTXTPRC'); {'Qual o texto ? '}
        c := sintEditaCampo (textoBusc, 1, wherey, 255, 80, true);
        writeln;
    until upcase(c) in [ENTER, ESC];
    if (c = ESC) or (trim(textoBusc) = '') then
        begin
                    fala ('EDDESIST');
            exit;
        end;

    repeat
        fala ('EDTODBLK'); {'Todo texto (T) ou bloco (B): '}
        c := sintreadkey;
        c := upcase (c);
    until c in ['T', 'B', ESC];
    if c = ESC then
        begin
                    fala ('EDDESIST');
            exit;
        end;

    if c = 'T' then
        begin
            yIni := 1;
            yFim := maxLinhas;
        end
    else
    if (c = 'B') and (fimbloco < iniBloco) then
         begin
             fala ('EDBLKINV');   { bloco invalido }
             exit;
         end
    else //Bloco vlido
        begin
            yIni := iniBloco;
            yFim := fimBloco;
        end;

    if apagaLinha then
        if textoBusc[length(textoBusc)] = '*' then
            begin
                delete (textobusc, length(textoBusc), 1);
                noInicio := true;
            end
        else noInicio := false;

    salvaIniBloco := iniBloco;
    salvaFimBloco := fimBloco;
    salvaY := posY;
    for y := yFim downto yIni do
        begin
            s := texto^[y]^;
            if trim (s) = '' then
                continue;

            if not apagaLinha then
                begin
                    if noInicio then
                        s := textoBusc + s
                    else
                        s := s + textoBusc;
                    posY := y;
                    Removelinha (false);
                    insereLinha (s, false);
                    continue;
                end;

            if noInicio then
                p := pos (textoBusc, copy (s, 1, length (textoBusc)))
            else
                p := pos (textoBusc, s);
            if p > 0 then
                begin
                    posY := y;
                    Removelinha (false);
                    if y <= salvaY then
                        salvaY := salvaY - 1;
                end;

        end;

    if not apagaLinha then
        begin
            iniBloco := salvaIniBloco;
            fimBloco := salvaFimBloco;
        end;

    posY := salvaY;
    if posY > maxLinhas then posY := maxLinhas
    else
    if posY < 1 then posY := 1;
    fala ('EDOK');
end;
//neno2
{--------------------------------------------------------}

procedure excluiLinhasComTexto;
begin
    editaOuApagaLinha (false, true);
    end;

{--------------------------------------------------------}

procedure cmdLinha;
var
     tecla: char;
label deNovo;

begin

    fala ('EDOPCAO');   { qual opcao ? }
    tecla := leTeclaMaiusc;

deNovo:
    escreveTela;

    case tecla of

       'I': insereLinha ('', true);
  'A', 'N': insereProxLinha ('', true);
       'R': Removelinha (true);
       'V': voltaRemovida;
       'Q': quebraLinha;
       'J': juntaLinhas;
       'E': excluiLinhasComTexto;
       'S': editaOuApagaLinha (true , false);
       'D': editaOuApagaLinha (false , false);

       #$0: begin
                tecla := ajuda (readkey, 'EDAJLI', 10);
                goto deNovo;
            end;
      #$1b: begin
                fala ('EDDESIST');
                exit;
            end
    end;

    escreveTela;
end;

{--------------------------------------------------------}
{       Insere uma string na linha
{--------------------------------------------------------}

procedure insereNaLinha (conteudo: string);
var
    linha, saida: string;
    salva, salvax: integer;
begin
    linha := texto^[posy]^;
    saida := copy (linha, 1, posx-1) + conteudo + copy (linha, posx, length(linha)-posx+1);
    salva := posy;
    salvax := posx;
    Removelinha (false);
    insereLinha (saida, false);
    posy := salva;
    posx := salvax + length (conteudo);
end;

end.
