{--------------------------------------------------------}
{
{    Tratamento de Blocos de Linhas
{
{    Autor: Marcelo Luis Pinheiro
{
{    Orientador Academico: Jose' Antonio Borges
{
{    Em 10/12/93
{
{--------------------------------------------------------}

Unit edBloco;

interface
uses
    DVcrt, DVWin, DVarq, DVdde, windows, sysUtils,
    edVars, edMensag, edLinha, edArq, edAcento, edEmbel, edTela, eddicion,
    edReform, edTransf;

function blocoInvalido: Boolean;
procedure cmdBloco;
procedure inicBloco;
procedure trataBloco;


implementation

{--------------------------------------------------------}

Procedure InicBloco;
begin
    inibloco := 1;
    fimbloco := 0;
    novoini  := 0;
end;

{--------------------------------------------------------}

procedure selecionaTodoTexto;
begin
    inibloco := 1;
    fimbloco := maxlinhas;
    fala ('EDBLKMAR'); {'Bloco marcado'}
end;

{--------------------------------------------------------}

function blocoInvalido: Boolean;
begin
    blocoInvalido := fimbloco < iniBloco;
end;

{--------------------------------------------------------}

Procedure copiaBloco;
Var
    tam, k : Integer;

Begin
    if blocoInvalido or
        ( (posy >= inibloco) and (posy <= fimbloco) ) then
         begin
             fala ('EDBLKINV');   { bloco invalido }
             exit;
         end;

    tam := fimbloco - inibloco + 1;

    For k := tam-1 downto 0 do
        insereLinha (texto^ [inibloco+k]^, false);

    fimbloco := inibloco + tam - 1;

    fala ('EDBLKCPY');
End;

{--------------------------------------------------------}

procedure falaQuantasPalavras;
var
    s: string;
    totalPalavras: int64;
    y: integer;

    procedure contaPalavras;
    var
        p: integer;
    begin
        s := trim(s);
        while s <> '' do
            begin
                totalPalavras := totalPalavras + 1;
                p := pos (' ', s);
                if p > 0 then
                    delete (s, 1, p)
                else
                     s := '';
                s := trim(s);
            end;
    end;

begin
    if blocoInvalido then
         begin
             fala ('EDBLKINV');   { bloco invalido }
             exit;
         end;

    for y := iniBloco to fimBloco do
        begin
            s := texto^[y]^;
            if trim(s) = '' then
                continue
            else
                contaPalavras;
        end;
    escreveNumero (totalPalavras);
    fala ('EDPALAVR'); {'palavras'}
    sintClek;
    if not keypressed then     delay (100);
end;

{--------------------------------------------------------}

procedure colocaEmMaiusculoMinusculo (maiusculo, primeiraMaiusculo, paraUTF8: boolean);
var
    salva, salvaini, salvafim, y: integer;
    tecla: char;
    s: string;

    function colocaPrimMaiuscula (s: string): string;
    var
        i: integer;
        proximaMaiusc: boolean;
    begin
        s := ansiLowerCase (s);
        proximaMaiusc := true;
        for i := 1 to length (s) do
            begin
                if (s [i] <> ' ') and proximaMaiusc then
                    begin
                        s [i] := (ansiUpperCase (s) [i]);
                        proximaMaiusc := false;
                    end
                else
                if s [i] = ' ' then
                    proximaMaiusc := true;
            end;
        colocaPrimMaiuscula := s;
    end;

begin
    if blocoInvalido then
         begin
             fala ('EDBLKINV');   { bloco invalido }
             exit;
         end;

    if maiusculo then
        fala ('EDMAIUSC')   { 'Deseja converter o bloco para maiscula?'}
    else
    if primeiraMaiusculo then
        fala ('EDPRIMAI')   { 'Deseja converter primeira letra de todo bloco para maiscula?'}
    else
    if paraUTF8 then
        fala ('EDPUTF8')   { 'Deseja codificar o bloco para UTF-8'}
    else
        fala ('EDMINUSC');   { 'Deseja converter o bloco para minscula?'}

    tecla := leTeclaMaiusc;
    if not (tecla in ['S', ENTER]) then
        begin
            fala ('EDDESIST');  { Desistiu }
            exit;
        end;

    salva := posy;
    salvaIni := inibloco;
    salvaFim := fimbloco;
    for y := iniBloco to fimBloco do
        begin
            s := texto^[y]^;
            if trim(s) = '' then
                continue
            else
            if maiusculo then
                s := ansiUpperCase (s)
            else
            if primeiraMaiusculo then
                s := colocaPrimMaiuscula (s)
            else
            if paraUTF8 then
                s := AnsiToUtf8(s)
            else
                s := ansiLowerCase (s);

            posy := y;
            Removelinha(false);
            insereLinha (s, false);
        end;

    posy := salva;
    inibloco := salvaini;
    fimbloco := salvafim;
    fala ('EDOK');
end;

{--------------------------------------------------------}

procedure tratamentoMaiusculaMinuscula;
var
    c: char;
label deNovo;
begin
    fala ('EDOPCAO');   { qual opcao ? }
    c := leTeclaMaiusc;
deNovo:
    escreveTela;

    case c of
        'A': colocaEmMaiusculoMinusculo (true, false, false);
        'I': colocaEmMaiusculoMinusculo (false, false, false);
        'P': colocaEmMaiusculoMinusculo (false, true, false);
        'U': colocaEmMaiusculoMinusculo (false, false, true);
        'C': falaQuantasPalavras;

        #$0: begin
                c:= ajuda (readkey, 'EDAJMM', 6);
                goto deNovo;
            end;
        #$1b:  begin
                fala ('EDDESIST');
                exit;
            end
    else
        sintBip;
    end;
end;

{--------------------------------------------------------}

Procedure Removebloco;
Var
   i : Integer;

Begin
    If blocoInvalido then
        begin
            fala ('EDBLKINV');
            exit;
        end;

    posy  := inibloco;
    For i := inibloco to fimbloco Do
        removeLinha (false);

    fala ('EDBLKREM');

    inicBloco;
End;

{--------------------------------------------------------}

Procedure moveBloco;
var
    tam, i : Integer;

begin
    if blocoInvalido or
        ( (posy >= inibloco) and (posy <= fimbloco) ) then
         begin
             fala ('EDBLKINV');   { bloco invalido }
             exit;
         end;

    tam := fimbloco - inibloco + 1;
    salvaCury:= posy;

    For i := tam-1 downto 0 do
        begin
            insereLinha (texto^ [fimbloco]^, false);
            posy := fimBloco;
            removeLinha (false);
            posy := salvaCury;
        end;

    posy := salvaCury;
    iniBloco := posy;
    fimBloco := iniBloco + tam - 1;

    fala ('EDBLKMOV');
end;

{--------------------------------------------------------}

Procedure LeBloco;
var
    salvaNome: string;
    salva: integer;

label fim;

begin
    salvaNome := nomeArq;
    salva := posy;

    if abreArqSemCriar then
        begin
            fimBloco := posy-1;
            iniBloco := salva;
            posy := salva;
            posx := 1;
            fala ('EDBLKCRG');
        end;

    nomeArq := salvaNome;

    if posy <= 0 then
        posy := 1;
end;

{--------------------------------------------------------}

Procedure GravaBloco;
var
    salvaNome: string;
    tecla: char;
    aux: boolean;
begin
    If BlocoInvalido  Then
        begin
            fala ('EDBLKINV');   { bloco Invalido }
            exit;
        end;

    salvanome := nomeArq;
    nomearq := '';

    fala ('EDREFORM');   { Junta linhas para exportar? }
    tecla := leTeclaMaiusc;
    aux := somenteLeitura;
    somenteLeitura := false;
    if tecla <> ESC then
        if upcase (tecla) <> 'S' then
            salvaArquivo (iniBloco, fimBloco)
        else
            salvaJuntaLinhas (iniBloco, fimBloco)
    else
        fala ('EDDESIST');   { Desistiu }
    somenteLeitura := aux;

    nomeArq := salvaNome;
end;

{--------------------------------------------------------}

Procedure AdicionaBloco;
Var
    salvaNome: string;
    adic : Text;
    i : Integer;

Label Inicio, fecha, fim;

Begin
    If blocoInvalido then
        begin
            fala ('EDBLKINV');
            exit;
         end;

Inicio :
    fala ('EDDIGNOM');
    salvaNome := Nomearq;
    nomeArq := obtemNomeArq (10);
    write (nomeArq);
    nomeArq := trim(nomeArq);
    if nomeArq = '' then
        begin
            fala ('EDDESIST');
            goto fim;
        end;

    if not testaExtensao (nomeArq) then
        begin
            assign (adic, nomeArq);
            {$i-} reset (adic); {$i+}
            if ioresult = 0 then
                {$i-} close (adic) {$i+}
            else
                nomeArq := nomeArq + '.txt';
        end;

    assign (adic, nomeArq);
    {$I-} append (adic); {$I+}
    If ioresult <> 0  Then
        begin
            fala('EDARQNAO');
            goto fim;
        end;

    For i := inibloco to fimbloco  Do
        begin
            {$I-} writeln (adic, texto^[i]^); {$I+}
            If ioResult <> 0  Then
                begin
                    fala ('EDERRESC');
                    goto fecha;
                end;
        end;

fecha:
    {$I-}  close (adic);  {$I+}
    if ioresult = 0 then
        fala ('EDBLKADC'); {  Bloco adicionado. }

fim:
    nomeArq := salvaNome;
End;

{--------------------------------------------------------}

Procedure OrdenaBloco;
Var i, j : Integer;
    pt : Frase;
Begin
    If blocoInvalido then
        begin
             fala ('EDBLKINV');
             exit;
        end;

    For i := IniBloco to fimBloco-1 do
        For j:= i+1 To fimBloco do
            if maiuscAnsi (semAcentos (texto^[j]^)) <    
               maiuscAnsi (semAcentos (texto^[i]^))  then
                begin
                    pt       := texto^[i];
                    texto^[i] := texto^[j];
                    texto^[j] := pt;
                end;

    fala ('EDBLKORD');
end;

{--------------------------------------------------------}

procedure blocoParagrafo;
begin
    inibloco := posy;
    fimBloco := posy;

    while (inibloco > 1) and (texto^[inibloco-1]^ <> '') do
        inibloco := inibloco - 1;

    while (fimbloco < maxlinhas) and (texto^[fimbloco+1]^ <> '') do
        fimbloco := fimbloco + 1;

    fala ('EDBLKPAR');
end;

{--------------------------------------------------------}

procedure enviaServidor;
var i: integer;
    servidor, topico, item: string [30];
    tamanho: longint;
    p: pchar;
    posic: integer;
begin
    servidor := sintAmbiente ('EDIVOX', 'SERVIDOR');
    if servidor = '' then
        servidor := 'MONOLOG';
    topico := sintAmbiente ('EDIVOX', 'TOPICO');
    if topico = '' then
        topico := 'TALK';
    item := sintAmbiente ('EDIVOX', 'ITEM');

    while sintFalando do waitMessage;

    tamanho := 1;
    for i := iniBloco to fimBloco do
        tamanho := tamanho + length (texto^[i]^) + 2;

    if tamanho > longint (65000) then
        begin
            fala ('EDGRANDE');
            exit;
        end;

    getmem (p, tamanho);
    posic := 0;

    for i := iniBloco to fimBloco do
        begin
            move (texto^[i]^[1], p[posic], length (texto^[i]^));
            posic := posic + length (texto^[i]^);
            p[posic] := #$0d;
            p[posic+1] := #$0a;
            posic := posic + 2;
        end;
    p[posic] := #$0;

    if not enviaServidorDDE (servidor, topico, item, p) then
        fala ('EDERRSRV');

    freemem (p, tamanho);
end;

{--------------------------------------------------------}

procedure justificaParagrafo;
begin
    inibloco := posy;
    fimBloco := posy;

    while (inibloco > 1) and (texto^[inibloco-1]^ <> '') do
        inibloco := inibloco - 1;

    while (fimbloco < maxlinhas) and (texto^[fimbloco+1]^ <> '') do
        fimbloco := fimbloco + 1;

    acertaMargens (false);
    inicBloco;
    fala ('EDJUSTIF');
end;

{--------------------------------------------------------}

procedure verificaBloco;
begin
    if blocoInvalido then
         begin
             fala ('EDBLKINV');   { bloco invalido }
             exit;
         end;

    if not verificaDicionario (iniBloco, fimBloco) then
        fala ('EDDICNAO');   {dicionrio no foi encontrado}
end;

{--------------------------------------------------------}

procedure removeLinhasEmBranco(removerTodas: boolean);
var
    i: integer;
    passouUma: boolean;
begin
    if blocoInvalido then
         begin
             fala ('EDBLKINV');   { bloco invalido }
             exit;
         end;

    passouUma := false;
    sintClek;
    for i := fimBloco downto iniBloco do
        if trim(texto^ [i]^) = '' then
            begin
                posy := i;
                if (removerTodas or passouUma) then
                    Removelinha(false)
                else
                    passouUma := true;
                if (i mod 100) = 0 then
                    sintClek;
            end
        else
    passouUma := false;

    posy := iniBloco;
    posx := 1;
end;

{--------------------------------------------------------}

Procedure TrataBloco;
Var
    c : char;
label deNovo;

Begin
    fala ('EDCMDBLK');     { bloco: }
    c := sintReadKey;

deNovo:
    case upcase(c) of
         'M' : movebloco;
         'C' : copiabloco;
         'A' : AdicionaBloco;
         'O' : OrdenaBloco;
         'R' : removebloco;

         'I' : begin
                   inibloco := posy;
                   fala ('EDINIBLK');    { inicio do bloco }
               end;

         'F' : begin
                   fimbloco := posy;
                   fala ('EDFIMBLK');    { fim do bloco }
               end;

         'D' : begin
                   inicBloco;
                   fala ('EDBLKDSM');   { bloco desmarcado }
               end;

         'L' : leBloco;
         'G' : gravaBloco;
         'E' : embelezaBloco;
         'P' : blocoParagrafo;
         'J' : justificaParagrafo;
         'S' : enviaServidor;
         'V' : verificaBloco;

         'X' : reformata;
         'U' : tratamentoMaiusculaMinuscula;
         'B' : removeLinhasEmBranco(true);
         ^B : removeLinhasEmBranco(false);

         'W' : areaTransfWord;
         'T' : selecionaTodoTexto;

        #$0: begin
                c := ajuda (readkey, 'EDAJBL', 22);
                goto deNovo;
             end;

         Else
             begin
                fala ('EDDESIST');
                exit;
            end
    end;
end;

{--------------------------------------------------------}

procedure cmdBloco;
var
    tecla: char;
label deNovo;
begin
    fala ('EDOPCAO');   { qual opcao ? }
    tecla := leTeclaMaiusc;
deNovo:
    escreveTela;

    case tecla of

         'M' : movebloco;
         'C' : copiabloco;
         'A' : AdicionaBloco;
         'O' : OrdenaBloco;
         'R' : removebloco;
         'I' : begin
                   inibloco :=posy;
                   fala ('EDINIBLK');    { inicio do bloco }
               end;
         'F' : begin
                   fimbloco := posy;
                   fala ('EDFIMBLK');    { fim do bloco }
               end;
         'D' : begin
                   inicBloco;
                   fala ('EDBLKDSM');    { bloco desmarcado }
               end;
         'L' : leBloco;
         'G' : gravaBloco;
         'E' : embelezaBloco;
         'P' : blocoParagrafo;

         'J' : justificaParagrafo;
         'S' : enviaServidor;
         'V' : verificaBloco;

         'X' : reformata;
         'U' : tratamentoMaiusculaMinuscula;
         'B' : removeLinhasEmBranco(true);
         ^B : removeLinhasEmBranco(false);

         'W' : areaTransfWord;
         'T' : selecionaTodoTexto;

       #$0: begin
                tecla := ajuda (readkey, 'EDAJBL', 22);
                goto deNovo;
            end;
      #$1b:  begin
                fala ('EDDESIST');
                exit;
            end
    else
        sintBip;
    end;

    escreveTela;
end;

end.
