{-------------------------------------------------------------}
{
{       Tratamento de arquivos PDF, converso para TXT
{
{       Autor: Neno Henrique da Cunha Albernaz
{
{       Em 12de Fevereiro de 2012
{
{-------------------------------------------------------------}

unit edPdf;

interface

uses
    windows,
    dvcrt,
    sysutils,
    dvwin,
    dvexec,
    edMensag,
    edVars;

function convertPdfParaTxt (nomeArq: string): string;

implementation

{----------------------------------------}
{       Retorna o arquivo com a extenso trocada, pdf para txt
{----------------------------------------}

function trocaExtensao (nomeArq: string): string;
var p: integer;
begin
    p :=3;
    while (nomeArq[length (nomeArq) - p] <> '.') and (p < length(nomeArq)) do
        p := p + 1;
    delete (nomeArq, length(nomeArq)-p, p + 1);
    nomeArq := nomeArq + '.txt';
    trocaExtensao := nomeArq;
end;

{--------------------------------------------------------}
{       Chama programa externo que converte pdf para txt.
{--------------------------------------------------------}

function chamaPdfToText: boolean;
var
    nomeProg, nomeArqConvert: string;
begin
    chamaPdfToText := false;
    nomeArqConvert := nomeArq;
    if pos (' ', nomeArq) <> 0 then
        if nomeArq [1] <> '"' then
            nomeArqConvert := '"' + nomeArq + '"';

    nomeProg := sintAmbiente ('EDIVOX', 'CONVERSORPDF');
    if nomeProg = '' then nomeProg := '"pdftotext" -nopgbrk -layout';
    if executaProg (nomeProg, '', nomeArqConvert) >= 32 then
        begin
            esperaProgVoltar;
            while sintFalando do waitMessage;
//neno            fala ('EDOK'); {'Ok'}
            chamaPdfToText := true;
        end
    else
        fala ('EDPDFNEX'); {'Falta o conversor de PDF para TXT, arquivo pdftotext'}
end;

{----------------------------------------}
{   Testa se o arquivo  .pdf, se for transforma em .txt
{----------------------------------------}

function convertPdfParaTxt (nomeArq: string): string;
var
    nomeArqTemp: string;
//neno    word: Variant;
    c: char;
begin
   convertPdfParaTxt := nomeArq;
    nomeArqTemp := upperCase (nomeArq);
    if pos ('.PDF',nomeArqTemp) <> length (nomeArqTemp) - 3 then exit;

    nomeArqTemp := nomeArq;
    nomeArq := trocaExtensao  (nomeArq);
    if fileExists (nomeArq) then
        begin
            repeat
                fala ('EDREESCR'); {'Arquivo j existe, reescreve (s/n) ?'}
                c := leTeclaMaiusc;
            until c in ['S', 'N', ENTER, ESC];
            if c = 'N' then
                begin
                   convertPdfParaTxt := nomeArq;
                    exit;
                end;
        end
    else
    repeat
        fala ('EDDESCON'); {'Deseja tentar converter o arquivo para TXT? '}
        c := leTeclaMaiusc;
    until c in ['S', 'N', ENTER, ESC];

    if c = ESC then
        begin
           convertPdfParaTxt := '';
            exit;
        end;
    if c = 'N' then
        exit;

    fala ('EDAGUARD'); {'Aguarde ...'}
    sintClek;
    if not chamaPdfToText then
        begin
           convertPdfParaTxt := '';
            exit;
        end;
    sintClek;
    convertPdfParaTxt := nomeArq;
end;

{--------------------------------------------------------}
begin
end.
